# Heygen v5 Digital Twin API

> Pacha wa kidijitali wa avatari V wenye tokeo la 4k, WebM yenye uwazi, mandharinyuma, alama ya maji na maelezo mafupi ya SRT

Huunda video ya avatari inayozungumza kutoka kwa maandishi (`prompt` na `voice`) au kutoka `audio_url` kwa usawazishaji wa midomo. Chagua `avatar` yenye jina, hali ya `fit` ya contain au cover, na mwonekano wa 720p, 1080p au 4k. `output_format` inaweza kuwa mp4 au webm; webm huwa na uwazi. Chaguo ni pamoja na uunganishaji wa mandharinyuma, wekeleo la alama ya maji na faili ya maelezo mafupi ya SRT ya pembeni.

- Model id: `heygen/avatar5/digital-twin`
- Made by: HeyGen
- Category: Lipsync & Avatars
- Output: video
- Price per second of your input audio: $0.10 / second of input audio (cheapest run $0.10 (100 API credits))
- Run: `POST https://api.doitong.ru/v1/run/heygen/avatar5/digital-twin`
- Quote: `POST https://api.doitong.ru/v1/quote/heygen/avatar5/digital-twin`
- Docs page: https://doitong.com/sw/developers/models/heygen/avatar5/digital-twin

## Pricing

Price: **$0.10 / second of input audio**. Price per second of your input audio: the input files are measured before the run (length, resolution, frame rate). The quote measures the same files and is exactly what the run charges.

The full example input below costs $1.00 = 1000 API credits (10 s input audio × $0.10).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.ru/v1/quote/heygen/avatar5/digital-twin` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `avatar` |  | string \| null | no | `Abigail Sofa Front` |  | Jina linalomtambulisha avatar anayestahiki Avatar V. |
| `prompt` |  | string \| null | no |  |  | Maandishi ya matamshi ya avatar; yanahitajika ikiwa `audio_url` haijatolewa. |
| `voice` |  | enum (string) \| null | no | `Warm Pro Narrator` | `Warm Pro Narrator`, `Chill Brian`, `Ivy`, `John Doe`, `Monika Sogam`, `Hope `, `Archer `, `Brittney`, `Patrick`, `David Castlemore`, `Michael C`, `Adam Stone `, `Juniper`, `Cassidy `, `Jessica Anne Bogart`, `Arabella`, `Andrew`, `Spuds Oxley `, `Grace Elder`, `Helen`, `Canyon Rivers`, `Derya - Lifelike - Excited 🤩`, `Mellow Marcus`, `Jack Sterling - Broadcaster 🎙️`, `Brenda - UGC - 1.mp4`, `Reid`, `Reagan`, `Terry`, `Jenny`, `Radio Rick`, `Denise`, `Tim in car - Excited 🤩`, `Iskander`, `Thompson`, `Delicate Daisy - Excited 🤩`, `Kingston`, `George UGC 1`, `Bold Blake`, `Jane`, `Expressive Evan`, `Marianne - IA`, `Aaron`, `Modern Recipe Host - Voice 1`, `Willow`, `Cute Chloe - Friendly 😊`, `Rafael`, `June - Lifelike`, `Crisp Chloe`, `Slick Simon`, `Nassim - Informative`, `Baritone Ben`, `Maxwell`, `Ellie Faye - Excited 🤩`, `Milani`, `Feisty Fiona - Excited 🤩`, `Professor Dean`, `Rose - UGC - 1.mp4`, `Shona`, `Hudson Wilder`, `Ann - IA`, `Alastair Kensington`, `Oxley`, `Christina`, `Andrew Rizz `, `Peyton`, `Gerardo - Outdoor`, `Chloe - Lifelike`, `Stephanie`, `Anthony - IA`, `Signal - Voice 1`, `Luca`, `Lisa - Voice 1`, `T.W.Tucker`, `Jack Sullivan - Serious 😐`, `Winter`, `Mireia - Lifelike`, `Georgia`, `Stella`, `Masha - Lifelike`, `Charming Charles - Friendly 😊`, `Serenity`, `Annie - Excited`, `Ralph`, `Bethany`, `Dominic`, `Mason Finn`, `Leena`, `Veteran Victor`, `Tamara`, `Nik Public`, `Calm Chloe`, `Sevik`, `Reilly`, `Raul`, `Imposing Ian`, `Relaxed Ray`, `Dexter - Professional`, `Relaxed Rick`, `Edwin`, `Rupert Blackwood`, `Ginny`, `Hope` | Uteuzi wa sauti ya avatar kwa jina kwa ajili ya kubadilisha maandishi kuwa sauti; hutumika tu bila `audio_url`. |
| `audio_url` | `audio` | string (audio URL) \| null | no |  |  | Chanzo cha kusawazisha midomo kinachotolewa kama URL ya faili ya sauti ya HTTP(S), kikibadilisha kubadilisha maandishi kuwa sauti kinapopatikana. `prompt` wala `voice` haitumiki katika hali hiyo. |
| `fit` |  | enum (string) | no | `cover` | `contain`, `cover` | Chagua fremu ya avatar: 'cover' hujaza fremu ya tokeo lakini inaweza kukata avatar, ilhali 'contain' huonyesha avatar yote lakini inaweza kuongeza kingo nyeusi. |
| `remove_background` |  | boolean | no | `false` |  | Uondoaji wa mandharinyuma ya avatar; unapatikana tu kwa avatar zinazotumia matting. |
| `background` |  | object {type, value} \| null | no |  |  | Tabaka la mandharinyuma linalowekwa kwa hiari nyuma ya avatar, isipokuwa kwa `output_format='webm'`: tokeo la webm lenye uwazi hupuuza mpangilio huu. |
| `background.type` |  | enum (string) | no | `color` | `color`, `image` | Aina ya mandharinyuma: `color` hubainisha rangi thabiti ya heksadesimali, huku `image` ikibainisha URL ya picha. |
| `background.value` |  | string | no | `#FFFFFF` |  | Maudhui ya mandharinyuma: rangi ya heksadesimali aina ikiwa ni `color`, au URL ya HTTP(S) aina ikiwa ni `image`. |
| `watermark` |  | object {image_url, scale, opacity, placement} \| null | no |  |  | Picha ya hiari inayotumika kama watermark juu ya video iliyozalishwa. |
| `watermark.image_url` |  | string (image URL) | yes |  |  | URL ya picha ya watermark inayotumia HTTP(S), kwa kuiweka juu ya video. |
| `watermark.scale` |  | number \| null | no |  | ≤ 2, > 0 | Ukubwa wa watermark kulingana na video, zaidi ya 0.0 hadi 2.0. |
| `watermark.opacity` |  | number \| null | no |  | 0 – 1 | Kiwango cha uwazi wa watermark: 0.0 ni uwazi kamili na 1.0 si wazi kabisa. |
| `watermark.placement` |  | enum (string) \| null | no |  | `top-left`, `top-right`, `bottom-left`, `bottom-right` | Nafasi ya watermark ndani ya video. |
| `caption` |  | boolean | no | `false` |  | Hudhibiti uzalishaji wa faili tofauti la manukuu ya SRT linaloambatana na video. |
| `output_format` |  | enum (string) | no | `mp4` | `mp4`, `webm` | Uteuzi wa kontena la video, ambapo `webm` huwezesha uwazi kupitia uondoaji wa mandharinyuma kiotomatiki; katika hali hiyo, `background` haina athari. |
| `resolution` |  | enum (string) | no | `720p` | `720p`, `1080p`, `4k` | Mipangilio chaguomsingi ya mwonekano wa tokeo lililozalishwa. |
| `aspect_ratio` |  | enum (string) | no | `16:9` | `16:9`, `9:16`, `4:5`, `5:4`, `1:1`, `auto` | Uteuzi wa uwiano wa picha wa video: 'auto' huomba HeyGen isome na ihifadhi uwiano wa chanzo, ikitumia '16:9' ikiwa haiwezi. Chaguo dhahiri za uwiano ni '16:9', '9:16', '4:5', '5:4', na '1:1'. |
| `enable_safety_checker` |  | boolean | no | `true` |  | Ukaguzi unaweza kulegezwa kwa kuweka false, ikiwa mpigaji simu ameidhinishwa. |

File parameters (`audio`) take a public `https://` URL, a `data:` URI up to 10 MB, or the `file_url` of an upload from `POST /files`.

## Example input

Required parameters only:

```json
{}
```

A fuller example:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
  "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.ru/v1/run/heygen/avatar5/digital-twin?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
    "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.ru/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.ru/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/heygen/avatar5/digital-twin?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
    "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.ru/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
    "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/heygen/avatar5/digital-twin", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.ru/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "heygen/avatar5/digital-twin",
      "input": {
        "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
        "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "heygen/avatar5/digital-twin",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 1000,
    "usd": "1.00",
    "charged": 1000,
    "refunded": 0
  },
  "input": {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
    "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
  },
  "output": {
    "video": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.mp4",
      "content_type": "video/mp4",
      "file_name": "0-output.mp4",
      "file_size": 1843200
    },
    "caption_file": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.mp4",
      "content_type": "video/mp4",
      "file_name": "0-output.mp4",
      "file_size": 1843200
    }
  },
  "outputs": [
    {
      "type": "video",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.mp4",
      "content_type": "video/mp4",
      "file_size": 1843200,
      "width": 1280,
      "height": 720,
      "duration": 5,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `video` | object {url, content_type, file_name, file_size} | Faili ya video iliyozalishwa na Avatar V. |
| `caption_file` | object {url, content_type, file_name, file_size} \| null | Faili la manukuu ya SRT linalozalishwa wakati `caption=True`, ikiwa huduma inatoa moja. |

## Related models

- [Kling AI Avatar 2.0 Pro](https://doitong.com/developers/models/kling-video/ai-avatar/v2/pro.md) (`kling-video/ai-avatar/v2/pro`): $0.115 / second of input audio
- [Sync Lipsync 3](https://doitong.com/developers/models/sync-lipsync/v3.md) (`sync-lipsync/v3`): $8.00 / minute of output video
- [VEED Fabric 1.0](https://doitong.com/developers/models/veed/fabric-1.0.md) (`veed/fabric-1.0`): from $0.08 / second of input audio
- [Heygen Lipsync - Precision](https://doitong.com/developers/models/heygen/v3/lipsync/precision.md) (`heygen/v3/lipsync/precision`): $0.10 / second of output video
- [Heygen Lipsync - Speed](https://doitong.com/developers/models/heygen/v3/lipsync/speed.md) (`heygen/v3/lipsync/speed`): $0.05 / second of output video
- [Heygen · Avatar3 · Digital Twin](https://doitong.com/developers/models/heygen/avatar3/digital-twin.md) (`heygen/avatar3/digital-twin`): $0.034 / second of input audio
- [Heygen · Avatar4 · Digital Twin](https://doitong.com/developers/models/heygen/avatar4/digital-twin.md) (`heygen/avatar4/digital-twin`): $0.10 / second of input audio
- [Heygen · Avatar4 · Image to Video](https://doitong.com/developers/models/heygen/avatar4/image-to-video.md) (`heygen/avatar4/image-to-video`): $0.10 / second of input audio

## Links

- HTML page: https://doitong.com/developers/models/heygen/avatar5/digital-twin
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=heygen/avatar5/digital-twin
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.ru/v1/models/heygen/avatar5/digital-twin
